package com.bbva.pzic.cards.dao.tx.mapper.impl;

import com.bbva.pzic.cards.EntityMock;
import com.bbva.pzic.cards.business.dto.InputGetCardCancellationVerification;
import com.bbva.pzic.cards.dao.model.mp3g.FormatoMPMS13G;
import com.bbva.pzic.cards.dao.model.mp3g.FormatoMPMS23G;
import com.bbva.pzic.cards.dao.model.mp3g.FormatoMPMS33G;
import com.bbva.pzic.cards.dao.model.mp3g.FormatoMPRM3G0;
import com.bbva.pzic.cards.dao.model.mp3g.mock.FormatsMp3gStubs;
import com.bbva.pzic.cards.facade.v1.dto.CancellationVerification;
import com.bbva.pzic.routine.commons.utils.DateUtils;
import com.bbva.pzic.routine.translator.facade.Translator;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import java.io.IOException;
import java.text.ParseException;

import static com.bbva.pzic.cards.EntityMock.ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT;
import static com.bbva.pzic.cards.EntityMock.ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT;
import static org.junit.Assert.*;
import static org.mockito.Mockito.when;

@RunWith(MockitoJUnitRunner.class)
public class TxGetCardCancellationVerificationV1MapperTest {

    @InjectMocks
    private TxGetCardCancellationVerificationV1Mapper mapper;

    @Mock
    private Translator translator;

    private FormatsMp3gStubs formatsMp3gStubs = FormatsMp3gStubs.getInstance();

    @Before
    public void init() {
        when(translator.translateBackendEnumValueStrictly("cancellationVerification.rate.unitRateType", "M")).thenReturn(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT);
        when(translator.translateBackendEnumValueStrictly("cancellationVerification.condition.formatType", "M")).thenReturn(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT);
    }

    @Test
    public void mapInFullTest() {
        InputGetCardCancellationVerification input = EntityMock.getInstance().getInputGetCardCancellationVerificationMock();

        FormatoMPRM3G0 result = mapper.mapIn(input);

        assertNotNull(result);
        assertNotNull(result.getIdetarj());

        assertEquals(input.getCardId(), result.getIdetarj());
    }

    @Test
    public void mapOutFormatoMPMS13GFullTest() throws IOException, ParseException {
        FormatoMPMS13G input = formatsMp3gStubs.getFormatoMPMS13GMock();

        CancellationVerification result = mapper.mapOutFormatoMPMS13G(input, new CancellationVerification());

        assertNotNull(result);
        assertNotNull(result.getCardHolder());
        assertNotNull(result.getCardHolder().getHolderName());
        assertNotNull(result.getGrantedCredit());
        assertNotNull(result.getGrantedCredit().getAmount());
        assertNotNull(result.getGrantedCredit().getCurrency());
        assertNotNull(result.getCutOffDate());
        assertNotNull(result.getRelatedContracts());
        assertNotNull(result.getRelatedContracts().get(0));
        assertNotNull(result.getRelatedContracts().get(0).getId());
        assertNotNull(result.getRelatedContracts().get(0).getContractId());

        assertEquals(input.getNomclie(), result.getCardHolder().getHolderName());
        assertEquals(input.getLincred(), result.getGrantedCredit().getAmount());
        assertEquals(input.getMonedl(), result.getGrantedCredit().getCurrency());
        assertEquals(DateUtils.toDate(input.getFultliq()), result.getCutOffDate());
        assertEquals(input.getContrat(), result.getRelatedContracts().get(0).getId());
        assertEquals(input.getContrat(), result.getRelatedContracts().get(0).getContractId());
    }

    @Test
    public void mapOutFormatoMPMS13GWithoutNonMandatoryParametersTest() throws IOException, ParseException {
        FormatoMPMS13G input = formatsMp3gStubs.getFormatoMPMS13GMock();
        input.setNomclie(null);
        input.setContrat(null);

        CancellationVerification result = mapper.mapOutFormatoMPMS13G(input, new CancellationVerification());

        assertNotNull(result);
        assertNull(result.getCardHolder());
        assertNotNull(result.getGrantedCredit());
        assertNotNull(result.getGrantedCredit().getAmount());
        assertNotNull(result.getGrantedCredit().getCurrency());
        assertNotNull(result.getCutOffDate());
        assertNull(result.getRelatedContracts());

        assertEquals(input.getLincred(), result.getGrantedCredit().getAmount());
        assertEquals(input.getMonedl(), result.getGrantedCredit().getCurrency());
        assertEquals(DateUtils.toDate(input.getFultliq()), result.getCutOffDate());
    }

    @Test
    public void mapOutFormatoMPMS13GEmptyTest() {
        CancellationVerification result = mapper.mapOutFormatoMPMS13G(new FormatoMPMS13G(), new CancellationVerification());

        assertNotNull(result);
        assertNull(result.getCardHolder());
        assertNull(result.getGrantedCredit());
        assertNull(result.getCutOffDate());
        assertNull(result.getRelatedContracts());
    }


    @Test
    public void mapOutFormatoMPMS23GFullTest() throws IOException {
        FormatoMPMS23G input = formatsMp3gStubs.getFormatoMPMS23GMock();

        CancellationVerification result = mapper.mapOutFormatoMPMS23G(input, new CancellationVerification());

        assertNotNull(result);
        assertNotNull(result.getDebtDetail());
        assertNotNull(result.getDebtDetail().get(0));
        assertNotNull(result.getDebtDetail().get(0).getCurrencyDebt());
        assertNotNull(result.getDebtDetail().get(0).getCancellationAmount());
        assertNotNull(result.getDebtDetail().get(0).getCancellationAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCancellationAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getDisposedBalance());
        assertNotNull(result.getDebtDetail().get(0).getDisposedBalance().getCurrentBalances());
        assertNotNull(result.getDebtDetail().get(0).getDisposedBalance().getCurrentBalances().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getDisposedBalance().getCurrentBalances().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getDisposedBalance().getPendingBalances());
        assertNotNull(result.getDebtDetail().get(0).getDisposedBalance().getPendingBalances().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getDisposedBalance().getPendingBalances().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getLiquidPendingDebt());
        assertNotNull(result.getDebtDetail().get(0).getLiquidPendingDebt().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getLiquidPendingDebt().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getLiquidPendingCapital());
        assertNotNull(result.getDebtDetail().get(0).getLiquidPendingCapital().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getLiquidPendingCapital().getCurrency());
        assertNotNull(result.getDebtDetail());
        assertNotNull(result.getDebtDetail().get(0));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCreditInsurance());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCreditInsurance().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCreditInsurance().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalInstallment());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalInstallment().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalInstallment().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getOverdraftBalances());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getOverdraftBalances().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getOverdraftBalances().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getId());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getId());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getId());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getId());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getId());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getId());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getId());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getId());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getCurrency());

        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrencyDebt());
        assertEquals(input.getImpcanc(), result.getDebtDetail().get(0).getCancellationAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCancellationAmount().getCurrency());
        assertEquals(input.getTotcobr(), result.getDebtDetail().get(0).getDisposedBalance().getCurrentBalances().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getDisposedBalance().getCurrentBalances().getCurrency());
        assertEquals(input.getImpauto(), result.getDebtDetail().get(0).getDisposedBalance().getPendingBalances().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getDisposedBalance().getPendingBalances().getCurrency());
        assertEquals(input.getCitotfc(), result.getDebtDetail().get(0).getLiquidPendingDebt().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getLiquidPendingDebt().getCurrency());
        assertEquals(input.getCcapliq(), result.getDebtDetail().get(0).getLiquidPendingCapital().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getLiquidPendingCapital().getCurrency());
        assertEquals(input.getSegdesg(), result.getDebtDetail().get(0).getCurrentDebt().getCreditInsurance().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getCreditInsurance().getCurrency());
        assertEquals(input.getCiscpet(), result.getDebtDetail().get(0).getCurrentDebt().getCapitalInstallment().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getCapitalInstallment().getCurrency());
        assertEquals(input.getCapvige(), result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt().getCurrency());
        assertEquals(input.getExcline(), result.getDebtDetail().get(0).getCurrentDebt().getOverdraftBalances().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getOverdraftBalances().getCurrency());
        assertEquals(input.getIdcomem(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getFormat().getFormatType());
        assertEquals(input.getCuotvig(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(0).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdcodis(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getFormat().getFormatType());
        assertEquals(input.getComflat(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(1).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdcogri(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getFormat().getFormatType());
        assertEquals(input.getComgrif(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(2).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdcoman(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getFormat().getFormatType());
        assertEquals(input.getCommant(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(3).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdcosob(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getFormat().getFormatType());
        assertEquals(input.getComsobr(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(4).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdcoec1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getFormat().getFormatType());
        assertEquals(input.getPorvige(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(5).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdcoec2(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getFormat().getFormatType());
        assertEquals(input.getSegries(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(6).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdcompe(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getFormat().getFormatType());
        assertEquals(input.getCompena(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getConditions().get(7).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdinava(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getIntavan(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdincom(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getIntcomp(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdincuo(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getIntinic(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdeximo(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getMoravig(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdexico(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getCompvig(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getCurrency());
    }

    @Test
    public void mapOutFormatoMPMS23GWithoutNonMandatoryParametersTest() throws IOException {
        FormatoMPMS23G input = formatsMp3gStubs.getFormatoMPMS23GMock();
        input.setTotcobr(null);
        input.setImpauto(null);
        input.setCitotfc(null);
        input.setCcapliq(null);
        input.setSegdesg(null);
        input.setCiscpet(null);
        input.setExcline(null);
        input.setIdcomem(null);
        input.setAmctyp1(null);
        input.setCuotvig(null);
        input.setIdcodis(null);
        input.setComflat(null);
        input.setIdcogri(null);
        input.setComgrif(null);
        input.setIdcoman(null);
        input.setCommant(null);
        input.setIdcosob(null);
        input.setComsobr(null);
        input.setIdcoec1(null);
        input.setPorvige(null);
        input.setIdcoec2(null);
        input.setSegries(null);
        input.setIdcompe(null);
        input.setCompena(null);

        CancellationVerification result = mapper.mapOutFormatoMPMS23G(input, new CancellationVerification());

        assertNotNull(result);
        assertNotNull(result.getDebtDetail());
        assertNotNull(result.getDebtDetail().get(0));
        assertNotNull(result.getDebtDetail().get(0).getCurrencyDebt());
        assertNotNull(result.getDebtDetail().get(0).getCancellationAmount());
        assertNotNull(result.getDebtDetail().get(0).getCancellationAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCancellationAmount().getCurrency());
        assertNull(result.getDebtDetail().get(0).getDisposedBalance());
        assertNull(result.getDebtDetail().get(0).getLiquidPendingDebt());
        assertNull(result.getDebtDetail().get(0).getLiquidPendingCapital());
        assertNotNull(result.getDebtDetail());
        assertNotNull(result.getDebtDetail().get(0));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt());
        assertNull(result.getDebtDetail().get(0).getCurrentDebt().getCreditInsurance());
        assertNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalInstallment());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt().getCurrency());
        assertNull(result.getDebtDetail().get(0).getCurrentDebt().getOverdraftBalances());
        assertNull(result.getDebtDetail().get(0).getCurrentDebt().getConditions());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4));
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getCurrency());

        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrencyDebt());
        assertEquals(input.getImpcanc(), result.getDebtDetail().get(0).getCancellationAmount().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCancellationAmount().getCurrency());
        assertEquals(input.getCapvige(), result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getCapitalDebt().getCurrency());
        assertEquals(input.getIdinava(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getIntavan(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdincom(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getIntcomp(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdincuo(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getIntinic(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdeximo(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getMoravig(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdexico(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getCompvig(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda1(), result.getDebtDetail().get(0).getCurrentDebt().getRates().getItemizeRates().get(4).getItemizeRatesUnit().getCurrency());
    }

    @Test
    public void mapOutFormatoMPMS33GFullTest() throws IOException {
        FormatoMPMS33G input = formatsMp3gStubs.getFormatoMPMS33GMock();

        CancellationVerification result = mapper.mapOutFormatoMPMS33G(input, new CancellationVerification());

        assertNotNull(result);
        assertNotNull(result.getDebtDetail());
        assertNotNull(result.getDebtDetail().get(0));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getFormatType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getAmount().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getAmount().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getCurrency());

        assertEquals(input.getSegven2(), result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance().getCurrency());
        assertEquals(input.getCiscpev(), result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment().getCurrency());
        assertEquals(input.getCapvenc(), result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt().getCurrency());
        assertEquals(input.getMonexcv(), result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances().getCurrency());
        assertEquals(input.getIdpvec2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getFormatType());
        assertEquals(input.getSegven1(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdpvmem(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getFormatType());
        assertEquals(input.getCuovenc(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdpvdis(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getFormatType());
        assertEquals(input.getComfven(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdpvgri(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getFormatType());
        assertEquals(input.getComgven(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdpvman(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getFormatType());
        assertEquals(input.getCompven(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdpvpen(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getFormatType());
        assertEquals(input.getCompag3(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdpvsob(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getFormatType());
        assertEquals(input.getComveso(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdpvec1(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getFormatType());
        assertEquals(input.getPorvenc(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getAmount().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getAmount().getCurrency());
        assertEquals(input.getIdpvmon(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getInteres(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdpvcuo(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getCincpev(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdpvimo(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getMoraven(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdpvico(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getIntvenc(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getCurrency());
    }

    @Test
    public void mapOutFormatoMPMS33GWithoutNonMandatoryParametersTest() throws IOException {
        FormatoMPMS33G input = formatsMp3gStubs.getFormatoMPMS33GMock();
        input.setSegven1(null);
        input.setCuovenc(null);
        input.setComfven(null);
        input.setComgven(null);
        input.setCompven(null);
        input.setCompag3(null);
        input.setComveso(null);
        input.setPorvenc(null);

        CancellationVerification result = mapper.mapOutFormatoMPMS33G(input, new CancellationVerification());

        assertNotNull(result);
        assertNotNull(result.getDebtDetail());
        assertNotNull(result.getDebtDetail().get(0));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getFormatType());
        assertNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getFormatType());
        assertNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getFormatType());
        assertNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getFormatType());
        assertNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getFormatType());
        assertNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getFormatType());
        assertNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getFormatType());
        assertNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getId());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getFormatType());
        assertNull(result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getCurrency());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3));
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getUnitRateType());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getAmount());
        assertNotNull(result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getCurrency());

        assertEquals(input.getSegven2(), result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getCreditInsurance().getCurrency());
        assertEquals(input.getCiscpev(), result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getCapitalInstallment().getCurrency());
        assertEquals(input.getCapvenc(), result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getCapitalDebt().getCurrency());
        assertEquals(input.getMonexcv(), result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getOverdraftBalances().getCurrency());
        assertEquals(input.getIdpvec2(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(0).getFormat().getFormatType());
        assertEquals(input.getIdpvmem(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(1).getFormat().getFormatType());
        assertEquals(input.getIdpvdis(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(2).getFormat().getFormatType());
        assertEquals(input.getIdpvgri(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(3).getFormat().getFormatType());
        assertEquals(input.getIdpvman(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(4).getFormat().getFormatType());
        assertEquals(input.getIdpvpen(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(5).getFormat().getFormatType());
        assertEquals(input.getIdpvsob(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(6).getFormat().getFormatType());
        assertEquals(input.getIdpvec1(), result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getId());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_CONDITION_FORMAT_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getConditions().get(7).getFormat().getFormatType());
        assertEquals(input.getIdpvmon(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getInteres(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(0).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdpvcuo(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getCincpev(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(1).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdpvimo(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getMoraven(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(2).getItemizeRatesUnit().getCurrency());
        assertEquals(input.getIdpvico(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getRateType());
        assertEquals(ENUM_CANCELLATION_VERIFICATION_RATE_UNIT_RATE_TYPE_AMOUNT, result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getUnitRateType());
        assertEquals(input.getIntvenc(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getAmount());
        assertEquals(input.getMoneda2(), result.getDebtDetail().get(0).getOverdueDebt().getRates().getItemizeRates().get(3).getItemizeRatesUnit().getCurrency());
    }
}

